summaryrefslogtreecommitdiff
path: root/tests/du/long-sloop.sh
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2012-08-30 14:13:12 +0200
committerJim Meyering <meyering@redhat.com>2012-08-30 18:55:59 +0200
commit9eb4c31eb78c28dd9f72d1cbb940270311be343c (patch)
treeea3078bc1b002a9f948ed41445ca32318002a1d3 /tests/du/long-sloop.sh
parent00f5ba15dd91a3d9780fe1fbd06a4df436ae6714 (diff)
downloadcoreutils-9eb4c31eb78c28dd9f72d1cbb940270311be343c.tar.xz
tests: add .sh and .pl suffixes to shell and perl tests, respectively
Not only this shrinks the size of the generated Makefile (from > 6300 lines to ~3000), but will allow further simplifications in future changes. * tests/Makefile.am (TEST_EXTENSIONS): Add '.sh' and '.pl'. (PL_LOG_COMPILER, SH_LOG_COMPILER): New, still defined simply to $(LOG_COMPILER) for the time being. (TESTS, root_tests): Adjust as described. * All tests: Rename as described.
Diffstat (limited to 'tests/du/long-sloop.sh')
-rwxr-xr-xtests/du/long-sloop.sh72
1 files changed, 72 insertions, 0 deletions
diff --git a/tests/du/long-sloop.sh b/tests/du/long-sloop.sh
new file mode 100755
index 000000000..48e2e30ac
--- /dev/null
+++ b/tests/du/long-sloop.sh
@@ -0,0 +1,72 @@
+#!/bin/sh
+# Use du to exercise a corner of fts's FTS_LOGICAL code.
+# Show that du fails with ELOOP (Too many levels of symbolic links)
+# when it encounters that condition.
+
+# Copyright (C) 2006-2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ du
+
+# Create lots of directories, each containing a single symlink
+# pointing at the next directory in the list.
+
+# This number should be larger than the number of symlinks allowed in
+# file name resolution, but not too large as a number of entries
+# in a single directory.
+n=400
+
+dir_list=$(seq $n)
+mkdir $dir_list || framework_failure_
+file=1
+i_minus_1=0
+for i in $dir_list $(expr $n + 1); do
+ case $i_minus_1 in
+ 0) ;;
+ *)
+ ln -s ../$i $i_minus_1/s || framework_failure_
+ file=$file/s;;
+ esac
+ i_minus_1=$i
+done
+echo foo > $i
+
+# If a system can handle this many symlinks in a file name,
+# just skip this test.
+
+# The following also serves to record in 'err' the string
+# corresponding to strerror (ELOOP). This is necessary because while
+# Linux/libc gives 'Too many levels of symbolic links', Solaris
+# renders it as "Number of symbolic links encountered during path
+# name traversal exceeds MAXSYMLINKS".
+
+cat $file > /dev/null 2> err &&
+ skip_ 'Your system appears to be able to handle more than $n symlinks
+in file name resolution'
+too_many=$(sed 's/.*: //' err)
+
+
+# With coreutils-5.93 there was no failure.
+# With coreutils-5.94 we get the desired diagnostic:
+# du: cannot access '1/s/s/s/.../s': Too many levels of symbolic links
+du -L 1 > /dev/null 2> out1 && fail=1
+sed "s, .1/s/s/s/[/s]*',," out1 > out || fail=1
+
+echo "du: cannot access: $too_many" > exp || fail=1
+
+compare exp out || fail=1
+
+Exit $fail